﻿using SvdCli.Storage;
using System.IO;

namespace SvdCli.ImageUtils.BlockDifferencingDiskImage
{
    internal static class BddImage
    {
        public static void CreateStandaloneBddImage(string path, uint blockSize, uint blockCount)
        {
            using var stream = File.Create(path);

            const int kb16 = CapacityUnits.KiloByte * 16;
            const int kb64 = CapacityUnits.KiloByte * 64;

            stream.WriteByte((byte)'B'); // Signature BDD2
            stream.WriteByte((byte)'D');
            stream.WriteByte((byte)'D');
            stream.WriteByte((byte)'2');
            stream.WriteByte(0); // Standalone
            stream.WriteLeu32(blockSize);
            stream.WriteLeu32(blockCount);
            stream.Position = kb16 + 8 * blockCount;
            //align to 64kb
            stream.SetLength(stream.Position + (kb64 - (stream.Position % kb64)));
        }

        private static void WriteLeu32(this Stream stream, uint value)
        {
            var buf = new[]
            {
                (byte)(value),
                (byte)(value>>8),
                (byte)(value>>16),
                (byte)(value>>24),
            };

            stream.Write(buf, 0, buf.Length);
        }
    }
}
